diff -uNrd -x CVS ircd-comstud-1.12-REL/lib/confparse.c ircd-devel/lib/confparse.c
--- ircd-comstud-1.12-REL/lib/confparse.c	Wed Dec 31 19:00:00 1969
+++ ircd-devel/lib/confparse.c	Tue Dec  5 12:23:14 2000
@@ -0,0 +1,418 @@
+/*
+**   Generic Config file parser (confparse.c)
+**   Copyright (C) 1999 Fred Jacobs, Chris Behrens
+**
+**   This program is free software; you can redistribute it and/or modify
+**   it under the terms of the GNU General Public License as published by
+**   the Free Software Foundation; either version 1, or (at your option)
+**   any later version.
+**
+**   This program is distributed in the hope that it will be useful,
+**   but WITHOUT ANY WARRANTY; without even the implied warranty of
+**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+**   GNU General Public License for more details.
+**
+**   You should have received a copy of the GNU General Public License
+**   along with this program; if not, write to the Free Software
+**   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+*/
+
+/*
+**  The idea of something this generic came solely from Fred Jacobs.
+**  I completely rewrote his implementation, however, although some
+**  pieces remain similar.  Thank you very much, Fred! :)
+**    - Chris
+*/
+
+#include "ircd_includes.h"
+#include "confparse.h"
+
+RCSID("$Id: confparse.c,v 1.2 2000/11/10 07:49:31 humble Exp $");
+
+static void config_error(char *format, ...);
+static CONFIGFILE *config_parse(char *filename, char *confdata);
+static void config_entry_free(CONFIGENTRY *ceptr);
+
+static void config_error(char *format, ...)
+{
+	va_list		ap;
+	char		buffer[1024];
+	char		*ptr;
+
+	va_start(ap, format);
+	vsprintf(buffer, format, ap);
+	va_end(ap);
+	if ((ptr = strchr(buffer, '\n')) != NULL)
+		*ptr = '\0';
+	syslog(LOG_NOTICE, "%s", buffer);
+}
+
+static CONFIGFILE *config_parse(char *filename, char *confdata)
+{
+	char		*ptr;
+	char		*start;
+	int			linenumber = 1;
+	CONFIGENTRY	*curce;
+	CONFIGENTRY	**lastce;
+	CONFIGENTRY	*cursection;
+
+	CONFIGFILE	*curcf;
+	CONFIGFILE	*lastcf;
+
+	lastcf = curcf = (CONFIGFILE *)MyMalloc(sizeof(CONFIGFILE));
+	memset(curcf, 0, sizeof(CONFIGFILE));
+	curcf->cf_filename = MyStrdup(filename);
+	lastce = &(curcf->cf_entries);
+	curce = NULL;
+	cursection = NULL;
+	for(ptr=confdata;*ptr;ptr++)
+	{
+		switch(*ptr)
+		{
+			case ';':
+				if (!curce)
+				{
+					config_error("%s:%i Ignoring extra semicolon\n",
+						filename, linenumber);
+					break;
+				}
+				if (!strcmp(curce->ce_varname, "include"))
+				{
+					CONFIGFILE	*cfptr;
+
+					if (!curce->ce_vardata)
+					{
+						config_error("%s:%i Ignoring \"include\": No filename given\n",
+							filename, linenumber);
+						config_entry_free(curce);
+						curce = NULL;
+						continue;
+					}
+					if (strlen(curce->ce_vardata) > 255)
+						curce->ce_vardata[255] = '\0';
+					cfptr = config_load(curce->ce_vardata);
+					if (cfptr)
+					{
+						lastcf->cf_next = cfptr;
+						lastcf = cfptr;
+					}
+					config_entry_free(curce);
+					curce = NULL;
+					continue;
+				}
+				*lastce = curce;
+				lastce = &(curce->ce_next);
+				curce->ce_fileposend = (ptr - confdata);
+				curce = NULL;
+				break;
+			case '{':
+				if (!curce)
+				{
+					config_error("%s:%i: No name for section start\n",
+							filename, linenumber);
+					continue;
+				}
+				else if (curce->ce_entries)
+				{
+					config_error("%s:%i: Ignoring extra section start\n",
+							filename, linenumber);
+					continue;
+				}
+				curce->ce_sectlinenum = linenumber;
+				lastce = &(curce->ce_entries);
+				cursection = curce;
+				curce = NULL;
+				break;
+			case '}':
+				if (curce)
+				{
+					config_error("%s:%i: Missing semicolon before close brace\n",
+						filename, linenumber);
+					config_entry_free(curce);
+					config_free(curcf);
+					return NULL;
+				}
+				else if (!cursection)
+				{
+					config_error("%s:%i: Ignoring extra close brace\n",
+						filename, linenumber);
+					continue;
+				}
+				curce = cursection;
+				cursection->ce_fileposend = (ptr - confdata);
+				cursection = cursection->ce_prevlevel;
+				if (!cursection)
+					lastce = &(curcf->cf_entries);
+				else
+					lastce = &(cursection->ce_entries);
+				for(;*lastce;lastce = &((*lastce)->ce_next))
+					continue;
+				break;
+			case '/':
+				if (*(ptr+1) == '/')
+				{
+					ptr += 2;
+					while(*ptr && (*ptr != '\n'))
+						ptr++;
+					if (!*ptr)
+						break;
+					ptr--; /* grab the \n on next loop thru */
+					continue;
+				}
+				else if (*(ptr+1) == '*')
+				{
+					int commentstart = linenumber;
+
+					for(ptr+=2;*ptr;ptr++)
+					{
+						if ((*ptr == '*') && (*(ptr+1) == '/'))
+						{
+							ptr++;
+							break;
+						}
+						else if (*ptr == '\n')
+							linenumber++;
+					}
+					if (!*ptr)
+					{
+						config_error("%s:%i Comment on this line does not end\n",
+							filename, commentstart);
+						config_entry_free(curce);
+						config_free(curcf);
+						return NULL;
+					}
+				}
+				break;
+			case '\"':
+				start = ++ptr;
+				for(;*ptr;ptr++)
+				{
+					if ((*ptr == '\\') && (*(ptr+1) == '\"'))
+					{
+						char *tptr = ptr;
+						while((*tptr = *(tptr+1)))
+							tptr++;
+					}
+					else if ((*ptr == '\"') || (*ptr == '\n'))
+						break;
+				}
+				if (!*ptr || (*ptr == '\n'))
+				{
+					config_error("%s:%i: Unterminated quote found\n",
+							filename, linenumber);
+					config_entry_free(curce);
+					config_free(curcf);
+					return NULL;
+				}
+				if (curce)
+				{
+					if (curce->ce_vardata)
+					{
+						config_error("%s:%i: Ignoring extra data\n",
+							filename, linenumber);
+					}
+					else
+					{
+						curce->ce_vardata = (char *)MyMalloc(ptr-start+1);
+						strncpy(curce->ce_vardata, start, ptr-start);
+						curce->ce_vardata[ptr-start] = '\0';
+						curce->ce_vardatanum = atoi(curce->ce_vardata);
+					}
+				}
+				else
+				{
+					curce = (CONFIGENTRY *)MyMalloc(sizeof(CONFIGENTRY));
+					memset(curce, 0, sizeof(CONFIGENTRY));
+					curce->ce_varname = (char *)MyMalloc(ptr-start+1);
+					strncpy(curce->ce_varname, start, ptr-start);
+					curce->ce_varname[ptr-start] = '\0';
+					curce->ce_varlinenum = linenumber;
+					curce->ce_fileptr = curcf;
+					curce->ce_prevlevel = cursection;
+					curce->ce_fileposstart = (start - confdata);
+				}
+				break;
+			case '\n':
+				linenumber++;
+				if (*(ptr+1) == '#')
+				{
+					ptr += 2;
+					while(*ptr && (*ptr != '\n'))
+						ptr++;
+					if (*ptr == '\n')
+					{
+						ptr--;
+						continue;
+					}
+				}
+				/* fall through */
+			case '\t':
+			case ' ':
+			case '\r':
+				break;
+			default:
+				if ((*ptr == '*') && (*(ptr+1) == '/'))
+				{
+					config_error("%s:%i Ignoring extra end comment\n",
+						filename, linenumber);
+					ptr++;
+					break;
+				}
+				start = ptr;
+				for(;*ptr;ptr++)
+				{
+					if ((*ptr == ' ') || (*ptr == '\t') || (*ptr == '\n') || (*ptr == ';'))
+						break;
+				}
+				if (!*ptr)
+				{
+					if (curce)
+						config_error("%s: Unexpected EOF for variable starting at %i\n",
+							filename, curce->ce_varlinenum);
+					else if (cursection)
+						config_error("%s: Unexpected EOF for section starting at %i\n",
+							filename, curce->ce_sectlinenum);
+					else
+						config_error("%s: Unexpected EOF.\n", filename);
+					config_entry_free(curce);
+					config_free(curcf);
+					return NULL;
+				}
+				if (curce)
+				{
+					if (curce->ce_vardata)
+					{
+						config_error("%s:%i: Ignoring extra data\n",
+							filename, linenumber);
+					}
+					else
+					{
+						curce->ce_vardata = (char *)MyMalloc(ptr-start+1);
+						strncpy(curce->ce_vardata, start, ptr-start);
+						curce->ce_vardata[ptr-start] = '\0';
+						curce->ce_vardatanum = atoi(curce->ce_vardata);
+					}
+				}
+				else
+				{
+					curce = (CONFIGENTRY *)MyMalloc(sizeof(CONFIGENTRY));
+					memset(curce, 0, sizeof(CONFIGENTRY));
+					curce->ce_varname = (char *)MyMalloc(ptr-start+1);
+					strncpy(curce->ce_varname, start, ptr-start);
+					curce->ce_varname[ptr-start] = '\0';
+					curce->ce_varlinenum = linenumber;
+					curce->ce_fileptr = curcf;
+					curce->ce_prevlevel = cursection;
+					curce->ce_fileposstart = (start - confdata);
+				}
+				if ((*ptr == ';') || (*ptr == '\n'))
+					ptr--;
+				break;
+		} /* switch */
+	} /* for */
+	if (curce)
+	{
+		config_error("%s: Unexpected EOF for variable starting on line %i\n",
+			filename, curce->ce_varlinenum);
+		config_entry_free(curce);
+		config_free(curcf);
+		return NULL;
+	}
+	else if (cursection)
+	{
+		config_error("%s: Unexpected EOF for section starting on line %i\n",
+				filename, cursection->ce_sectlinenum);
+		config_free(curcf);
+		return NULL;
+	}
+	return curcf;
+}
+
+static void config_entry_free(CONFIGENTRY *ceptr)
+{
+	CONFIGENTRY	*nptr;
+
+	for(;ceptr;ceptr=nptr)
+	{
+		nptr = ceptr->ce_next;
+		if (ceptr->ce_entries)
+			config_entry_free(ceptr->ce_entries);
+		if (ceptr->ce_varname)
+			MyFree(ceptr->ce_varname);
+		if (ceptr->ce_vardata)
+			MyFree(ceptr->ce_vardata);
+		MyFree(ceptr);
+	}
+}
+
+void config_free(CONFIGFILE *cfptr)
+{
+	CONFIGFILE	*nptr;
+
+	for(;cfptr;cfptr=nptr)
+	{
+		nptr = cfptr->cf_next;
+		if (cfptr->cf_entries)
+			config_entry_free(cfptr->cf_entries);
+		if (cfptr->cf_filename)
+			MyFree(cfptr->cf_filename);
+		MyFree(cfptr);
+	}
+}
+
+CONFIGFILE *config_load(char *filename)
+{
+	struct stat sb;
+	int			fd;
+	int			ret;
+	char		*buf = NULL;
+	CONFIGFILE	*cfptr;
+
+	fd = open(filename, O_RDONLY);
+	if (fd == -1)
+	{
+		config_error("Couldn't open \"%s\": %i\n", filename, errno);
+		return NULL;
+	}
+	if (fstat(fd, &sb) == -1)
+	{
+		config_error("Couldn't fstat \"%s\": %i\n", filename, errno);
+		close(fd);
+		return NULL;
+	}
+	if (!sb.st_size)
+	{
+		close(fd);
+		return NULL;
+	}
+	buf = (char *)MyMalloc(sb.st_size+1);
+	if (buf == NULL)
+	{
+		config_error("Out of memory trying to load \"%s\"\n", filename);
+		close(fd);
+		return NULL;
+	}
+	ret = read(fd, buf, sb.st_size);
+	if (ret != sb.st_size)
+	{
+		config_error("Error reading \"%s\": %i\n", filename,
+			ret == -1 ? errno : EFAULT);
+		MyFree(buf);
+		close(fd);
+		return NULL;
+	}
+	buf[ret] = '\0';
+	close(fd);
+	cfptr = config_parse(filename, buf);
+	MyFree(buf);
+	return cfptr;
+}
+
+CONFIGENTRY *config_find(CONFIGENTRY *ceptr, char *name)
+{
+	for(;ceptr;ceptr=ceptr->ce_next)
+		if (!strcmp(ceptr->ce_varname, name))
+			break;
+	return ceptr;
+}
+
diff -uNrd -x CVS ircd-comstud-1.12-REL/lib/fdlist.c ircd-devel/lib/fdlist.c
--- ircd-comstud-1.12-REL/lib/fdlist.c	Mon Jun 14 17:42:44 1999
+++ ircd-devel/lib/fdlist.c	Sun Dec 10 06:50:38 2000
@@ -22,182 +22,56 @@
 
 RCSID("$Id: fdlist.c,v 1.6 1999/02/03 01:14:07 cbehrens Exp $");
 
-int fdlist_add_fd(FDLIST *fdlist, int fd, int flags)
-{
-	int	n;
-
-	if (!fdlist || (fd < 0) ||
-			!(flags & (FDLIST_FLAGS_READ|FDLIST_FLAGS_WRITE)))
-	{
-		return -EINVAL;
-	}
-	if ((n=fdlist->pfd_num) == fdlist->pfd_size)
-	{
-		void 	*ptr;
+extern struct kevent *kqchange;
+extern int kqchangesize;
+extern int kqchangepos;
 
-		fdlist->pfd_size += 16;
-		ptr = realloc(fdlist->pfd_array,
-					fdlist->pfd_size * sizeof(FDLIST_POLLFD));
-		if (!ptr)
-		{
-			fdlist->pfd_size -= 16;
-			return -ENOMEM;
-		}
-		fdlist->pfd_array = (FDLIST_POLLFD *)ptr;
-	}
-	fdlist->pfd_array[n].fd = fd;
-	fdlist->pfd_array[n].revents = 0;
-	fdlist->pfd_array[n].events = 0;
-	if (flags & FDLIST_FLAGS_READ)
-		fdlist->pfd_array[n].events |= POLLIN;
-	if (flags & FDLIST_FLAGS_WRITE)
-		fdlist->pfd_array[n].events |= POLLOUT;
-	return fdlist->pfd_num++;
+struct kevent *fdlist_kqueue_increase(struct kevent *kq, int kqsize)
+{
+	return (struct kevent *)MyRealloc(kq, kqsize * sizeof(struct kevent));
 }
 
-int fdlist_del_fd(FDLIST *fdlist, int pos, int *mfd)
+static int _fdlist_event(IRCD_CONN *cptr, int flags, int filter)
 {
-	int		n;
+	struct kevent *kv;
 
-	if (!fdlist || (pos > (n = fdlist->pfd_num)) || (pos < 0))
-	{
-		return -EINVAL;
-	}
-	if (mfd)
-		*mfd = -1;
-	if ((--fdlist->pfd_num) && (n-1 != pos))
+	if (kqchangesize < kqchangepos + 64)
 	{
-		BCOPY(&(fdlist->pfd_array[n-1]), &(fdlist->pfd_array[pos]),
-			sizeof(FDLIST_POLLFD));
-		if (mfd)
-			*mfd = fdlist->pfd_array[pos].fd;
+		kqchangesize += 64;
+		if ((kqchange = fdlist_kqueue_increase(kqchange, kqchangesize)) == NULL)
+			return -ENOMEM;
 	}
-	return fdlist->pfd_num;
-}
-
-int fdlist_add_event(FDLIST *fdlist, int pos, int flags)
-{
-	if (!fdlist || (pos > fdlist->pfd_num) || (pos < 0))
-		return -EINVAL;
-	if (flags & FDLIST_FLAGS_READ)
-		fdlist->pfd_array[pos].events |= POLLIN;
-	if (flags & FDLIST_FLAGS_WRITE)
-		fdlist->pfd_array[pos].events |= POLLOUT;
-	return fdlist->pfd_array[pos].events;
-}
-
-int fdlist_del_event(FDLIST *fdlist, int pos, int flags)
-{
-	if (!fdlist || (pos > fdlist->pfd_num) || (pos < 0))
-		return -EINVAL;
-	if (flags & FDLIST_FLAGS_READ)
-		fdlist->pfd_array[pos].events &= ~POLLIN;
-	if (flags & FDLIST_FLAGS_WRITE)
-		fdlist->pfd_array[pos].events &= ~POLLOUT;
-	return fdlist->pfd_array[pos].events;
-}
-
-int fdlist_set_events(FDLIST *fdlist, int pos, int flags)
-{
-	if (!fdlist || (pos > fdlist->pfd_num) || (pos < 0) || !flags)
-		return -EINVAL;
-	fdlist->pfd_array[pos].events = 0;
-	if (flags & FDLIST_FLAGS_READ)
-		fdlist->pfd_array[pos].events |= POLLIN;
-	if (flags & FDLIST_FLAGS_WRITE)
-		fdlist->pfd_array[pos].events |= POLLOUT;
-	return fdlist->pfd_array[pos].events;
-}
-
-int fdlist_get_events(FDLIST *fdlist, int pos)
-{
-	int flags = 0;
 
-	if (!fdlist || (pos > fdlist->pfd_num) || (pos < 0))
-		return -EINVAL;
-	if (fdlist->pfd_array[pos].events & POLLIN)
-		flags |= FDLIST_FLAGS_READ;
-	if (fdlist->pfd_array[pos].events & POLLOUT)
-		flags |= FDLIST_FLAGS_WRITE;
-	return flags;
-}
-
-
-#if 0
+	kv = kqchange + kqchangepos++;
 
-int fdlist_add_fd(FDLIST *fdlist, int fd, int flags)
-{
-	if (!fdlist || (fd < 0) ||
-			!(flags & (FDLIST_FLAGS_READ|FDLIST_FLAGS_WRITE)))
-		return -EINVAL;
-	if (fd < fdlist->lowest_fd)
-		fdlist->lowest_fd = fd;
-	if (flags & FDLIST_FLAGS_READ)
-		FD_SET(fd, &fdlist->read_fds);
-	if (flags & FDLIST_FLAGS_WRITE)
-		FD_SET(fd, &fdlist->write_fds);
-	fdlist->pfd_num++;
-	return fd;
-}
+	kv->ident = cptr->fd;
+	kv->flags = flags;
+	kv->filter = filter;
+	kv->fflags = 0;
+	kv->data = NULL;
+	kv->udata = cptr;
 
-int fdlist_del_fd(FDLIST *fdlist, int fd, int *mfd)
-{
-	if (!fdlist || (fd < 0))
-		return -EINVAL;
-	if (mfd)
-		*mfd = -1;
-	FD_CLR(fd, &fdlist->read_fds);
-	FD_CLR(fd, &fdlist->write_fds);
-	fdlist->pfd_num--;
 	return 0;
 }
 
-int fdlist_add_event(FDLIST *fdlist, int fd, int flags)
-{
-	if (!fdlist || (fd < 0))
-		return -EINVAL;
-	if (flags & FDLIST_FLAGS_READ)
-		FD_SET(fd, &fdlist->read_fds);
-	if (flags & FDLIST_FLAGS_WRITE)
-		FD_SET(fd, &fdlist->write_fds);
-	return 0;
-}
-
-int fdlist_del_event(FDLIST *fdlist, int fd, int flags)
+int fdlist_add_event(IRCD_CONN *cptr, int flags)
 {
-	if (!fdlist || (fd < 0))
-		return -EINVAL;
-	if (flags & FDLIST_FLAGS_READ)
-		FD_CLR(fd, &fdlist->read_fds);
-	if (flags & FDLIST_FLAGS_WRITE)
-		FD_CLR(fd, &fdlist->write_fds);
-	return 0;
-}
+        if (flags & FDLIST_FLAGS_READ)
+		_fdlist_event(cptr, EV_ADD, EVFILT_READ);
+                
+        if (flags & FDLIST_FLAGS_WRITE)
+		_fdlist_event(cptr, EV_ADD, EVFILT_WRITE);
 
-int fdlist_set_events(FDLIST *fdlist, int fd, int flags)
-{
-	if (!fdlist || (fd < 0) || !flags)
-		return -EINVAL;
-	FD_CLR(fd, &fdlist->read_fds);
-	FD_CLR(fd, &fdlist->write_fds);
-	if (flags & FDLIST_FLAGS_READ)
-		FD_SET(fd, &fdlist->read_fds);
-	if (flags & FDLIST_FLAGS_WRITE)
-		FD_SET(fd, &fdlist->write_fds);
 	return 0;
 }
 
-int fdlist_get_events(FDLIST *fdlist, int fd)
+int fdlist_del_event(IRCD_CONN *cptr, int flags)
 {
-	int flags = 0;
+        if (flags & FDLIST_FLAGS_READ)
+		_fdlist_event(cptr, EV_DELETE, EVFILT_READ);
+                
+        if (flags & FDLIST_FLAGS_WRITE)
+		_fdlist_event(cptr, EV_DELETE, EVFILT_WRITE);
 
-	if (!fdlist || (fd < 0))
-		return -EINVAL;
-	if (FD_ISSET(fd, &fdlist->read_fds))
-		flags |= FDLIST_FLAGS_READ;
-	if (FD_ISSET(fd, &fdlist->write_fds))
-		flags |= FDLIST_FLAGS_WRITE;
-	return flags;
+	return 0;
 }
-
-#endif /* 0 */
